#ifndef  _APP_DELEGATE_H_
#define  _APP_DELEGATE_H_

#define COCOS2D_DEBUG 1
#include "cocos2d.h"
#include "cocostudio/CocoStudio.h"
#include "ui/CocosGUI.h"
#include "NativeHelper.h"
#include "MazeScene.h"

#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
#define SOUNDS_EXT "aac"
#elif (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
#define SOUNDS_EXT "ogg"
#else
#define SOUNDS_EXT "wav"
#endif

USING_NS_CC;
using namespace std;

/**
 @brief    The cocos2d Application.
 
 The reason for implement as private inheritance is to hide some interface call by Director.
 */
class  AppDelegate : private cocos2d::Application
{
public:
    AppDelegate();
    virtual ~AppDelegate();
    
    virtual void initGLContextAttrs();
    
    /**
     @brief    Implement Director and Scene init code here.
     @return true    Initialize success, app continue.
     @return false   Initialize failed, app terminate.
     */
    virtual bool applicationDidFinishLaunching();
    
    /**
     @brief  The function be called when the application enter background
     @param  the pointer of the application
     */
    virtual void applicationDidEnterBackground();
    
    /**
     @brief  The function be called when the application enter foreground
     @param  the pointer of the application
     */
    virtual void applicationWillEnterForeground();
    
    float offsetX;
    float offsetY;
    float gameScale;
};

#endif // _APP_DELEGATE_H_

