//
//  PlayScene.h
//  NativeHelperTest
//
//  Created by Piotr on 04.03.2015.
//
//

#ifndef __MazeScene__
#define __MazeScene__

#include "cocos2d.h"
#include "cocostudio/CocoStudio.h"
#include "Utils.h"
#include "NativeHelper.h"
#include "AppDelegate.h"
#include "AntialiasEffect.h"

#define DRAW_RADIUS 21.0f
#define DRAW_COLOR Color4F(34 / 255.0f, 160 / 255.0f, 204 / 255.0f, 255 / 255.0f)
#define DRAW_DISTANCE 30
#define START_DISTANCE 60

USING_NS_CC;
using namespace cocostudio::timeline;

class MazeScene : public cocos2d::Layer
{
public:
    static cocos2d::Scene* createScene();
    virtual bool init();
    virtual void onKeyReleased(EventKeyboard::KeyCode keyCode, Event *event);
    void onBackPressed();
    void drawLine(int x1, int y1, int x2, int y2);
    
    CREATE_FUNC(MazeScene);
    
    Node* root;
    
    int touchID;
    Node* drawingLayer;
    RenderTexture* renderTexture;
    DrawNode* drawNode;
    cocos2d::Point lastLocation;
    vector<cocos2d::Point > points;
    
    Node* startNode;
    Node* endNode;

private:
    ~MazeScene();
};

#endif /* defined(__MazeScene__) */
