#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)

#import "AppController.h"
#include "NativeHelper.h"

bool NativeHelper::instanceFlag = false;
bool NativeHelper::isBannerShowing = true;
bool NativeHelper::full = false;
string NativeHelper::fullId = "";
NativeHelper* NativeHelper::instance = NULL;

NativeHelper* NativeHelper::getInstance()
{
    if(!instanceFlag){
        instance = new NativeHelper();
        instanceFlag = true;
        instance->purchaseCallback = nullptr;
        instance->purchaseCancelledCallback = nullptr;
        instance->imagePickedCallback = nullptr;
        instance->photoTakenCallback = nullptr;
        instance->productPriceCallback = nullptr;
        instance->videosExitCallback = nullptr;
    }
    
    return instance;
}

void NativeHelper::showBanner(int position){}

void NativeHelper::hideBanner(){}

void NativeHelper::showInterstitial(string eventName, string adSdk){}

void NativeHelper::adsSceneEnter(string name, int bannerPosition){}

void NativeHelper::adsSceneExit(string name){}

void NativeHelper::reportScreenChange(string name){}

void NativeHelper::getProductPrice(string product){}

void NativeHelper::purchaseProduct(string product){}

void NativeHelper::restorePurchases(){}

void NativeHelper::sendEmail(string subject, string body, string attachmentPath){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    [appController sendEmail:subject :body :attachmentPath];
}

void NativeHelper::showImagePicker(){}

string NativeHelper::getDeviceId(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController getDeviceId];
}

string NativeHelper::getAppVersion(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController getAppVersion];
}

string NativeHelper::getTempPath(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController getTempPath];
}

string NativeHelper::getStoragePath(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController getStoragePath];
}

void NativeHelper::goToVideos(){}

void NativeHelper::takePhoto(){}

string NativeHelper::getRateLink(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController getRateLink];
}

string NativeHelper::getFullLink(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController getFullLink];
}

string NativeHelper::getBundleId(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController getBundleId];
}

bool NativeHelper::isFull(){
    AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    return [appController isFull];
}

void NativeHelper::openAppUrl(string url){
    //AppController *appController = (AppController* )[UIApplication sharedApplication].delegate;
    //[appController openiTunesInsideApp: url];
}

float NativeHelper::getDeviceScaleFactor(){
    return 1.0f;
}

void NativeHelper::loadSettings(){
    NativeHelper::fullId = UserDefault::getInstance()->getStringForKey("fullId", "");
    if(NativeHelper::fullId == NativeHelper::getDeviceId()){
        NativeHelper::full = true;
    }
    else{
        NativeHelper::full = false;
    }
}

void NativeHelper::saveSettings(){
    UserDefault::getInstance()->setStringForKey("fullId", NativeHelper::fullId);
    UserDefault::getInstance()->flush();
}

void NativeHelper::setTotalPoints(int points){}

void NativeHelper::reportScore(){}

void NativeHelper::showLeaderboard(){}

void NativeHelper::showAchievements(){}

void NativeHelper::unlockAchievement(int index){}

#endif
