/*
 * Utils.h
 *
 *  Created on: 24 lut 2015
 *      Author: piotr
 */

#ifndef UTILS_H_
#define UTILS_H_

#include <string>
#include <sstream>
#include <ctime>
#include "cocos2d.h"
#include "AppDelegate.h"
#include "SimpleAudioEngine.h"
#include <spine/spine-cocos2dx.h>

USING_NS_CC;
using namespace std;
using namespace spine;

Sprite* forceLoadSprite(string filename, bool deleteAfterLoad);

std::string to_str(int t);
std::string to_str(float t);
std::string to_str(long t);
std::string to_str(double t);
std::string int_to_str(int i);
int from_str_to_int(std::string t);
long from_str_to_long(std::string t);
double from_str_to_double(std::string t);
float from_str_to_float(std::string t);
float f_round(float dval, int n);

bool isSpriteTouched(Vec2 pos, Node* child);
void lookAt(Node* node, cocos2d::Point from, cocos2d::Point to, float radius);
ParticleSystemQuad* createEmitter(string filename);
void playEmitterAt(cocos2d::Point pos, Vector<ParticleSystemQuad*> *memitters, bool burstAtStart, float emissionRate = 15, int index = -1);
void playEmitterOnce(cocos2d::Point pos, Vector<ParticleSystemQuad* > *memitters, int amount, float time, int index = -1);
void stopEmitters(Vector<ParticleSystemQuad*> *memitters);

void uPlayBackgroundMusic(string filenameWithoutExtension);
void uPlayBackgroundMusic(string filenameWithoutExtension, bool loop);
void uStopBackgroundMusic();
unsigned int uPlayEffect(string filenameWithoutExtension, bool loop);
unsigned int uPlayEffect(string filenameWithoutExtension);
void uPreloadEffect(string filenameWithoutExtension);
void uUnloadEffect(string filenameWithoutExtension);
void uPauseEffect(unsigned int soundId);
void uStopEffect(unsigned int soundId);
void uResumeEffect(unsigned int soundId);
bool uIsBackgroundMusicPlaying();
void translateNode(Node* node, Vec2 vec);

void fillWithFrames(Vector<SpriteFrame* > *v, string name, int from, int to, int back, int repeat = 1);
void addFrame(Vector<SpriteFrame* > *v, string name, int index);

void setAllMixes(SkeletonAnimation* anim, float time = 0.5f);
void setMultipleMixes(SkeletonAnimation* anim, vector<string> names1, vector<string> names2, bool both = true, float time = 0.5f);

string formatTimeFloat(float number);
string formatTimeFloat1(float number);

string getCurrentDateAndTime(time_t offset = 0);
time_t getCurrentDateAndTimeAsLong(time_t offset = 0);

void split(const std::string &s, char delim, std::vector<std::string> &elems);
std::vector<std::string> split(const std::string &s, char delim);

#endif /* UTILS_H_ */
