#import <UIKit/UIKit.h>
#import "NativeHelper.h"
#import <CommonCrypto/CommonHMAC.h>

@class RootViewController;

@interface AppController : NSObject <UIApplicationDelegate, UIAlertViewDelegate> {
    UIWindow *window;
}

@property(nonatomic, readonly) RootViewController* viewController;
@property (nonatomic, readwrite) BOOL czyOpeniTunes;
@property (nonatomic, readwrite) BOOL czyOpenCamera;

//-----
- (void) hideBanner;
- (void) showBanner:(int) position;
- (void) showInterstitial:(std::string) eventName :(std::string) adSdk;
- (void) adsSceneEnter:(std::string) name :(int) bannerPosition;
- (void) adsSceneExit:(std::string) name;
- (void) reportScreenChange:(std::string) name;
- (void) purchaseProduct:(std::string) product;
- (void) restorePurchases;
- (void) sendEmail:(std::string) subject :(std::string) body :(std::string) attachmentPath;
- (void) showImagePicker;
- (std::string) getDeviceId;
- (std::string) getAppVersion;
- (std::string) getTempPath;
- (std::string) getStoragePath;
- (void) takePhoto;
- (void) goToVideos;
- (void) getProductPrice:(std::string) product;
- (std::string) getRateLink;
- (std::string) getFullLink;
- (std::string) getBundleId;
- (bool) isFull;
- (void) videosExit;
- (UIWindow*) getWindow;

@end

